﻿/*******************
ENGLISH
project: 3d engine
by: ivan ivanoff (www.i2off.org)
based on the work made by : stuart schoneveld (www.illogicz.com) 
email: avatar@i2off.org
apologies:
to my wife and kids for supporting me.
to jorge, valerialaura & mariano, for bothering them all the time.
thx to valerialaura for the english translation
version:0.41
--------------------
ABOUT THIS CLASS
It's instanciated by the engine's component. It contains the render systme and the global properties.
--------------------
ABOUT IT'S PUBLIC METHODS
-addModel(model)
adds a new model to the scene. model is an instance of the Model class
returns the added model.
-removeModel(model)
removes a model from the scene. model is an instance of the 
Model class previously added to the scene.
-getModels()
returns a list of all available models.
-removeCamera(cam)
removes a camera from the scene. cam is an instance of the Camera3D class.
-setCamera(cam)
adds and sets the camera to use in the scene. cam is an instance of the Camera3D class.
-reset()
removes all models and cleans the scene.
-setScene(int)
sets a scene as active eliminating the current scene. int is an integer representing
the scene number of the list of available scenes setted with the property: scenes.
-onFreezeModel()
event to be overwritten. notifies the moment when a model is freezed. 
-addTexture(layer, texture)
allows the given layer to be used as a mask for an item in the library (texture)
--------------------

ABOUT IT'S PUBLIC PROPERTIES
-layers
the amount of different layers you wish to use. Models can be assigned
to different layers. If a model is set in front of another but on an 
lower layer, it will be shown behind.
layers are great for working with textures.

-freezeMode
sets whether freeze mode is active or not. freeze mode active stops rendering
sections of a freezed model.

-porFrezar
this value affects the chance of freezing.
the freezing will occur on a chance of 1/porFrezar.

-FXNMode
whether the FXN (where N is 1,2, etc) mode is on or off.
FX can stop, strech or contract parts of the affected polygon.

-FXNFac
this value is used on the calculation of the FX.

-scenes
a list containing the different scenes. These are functions receiving
an instance of the engine as it's parameter. Every scene has the 
step by step description of camera and polygons creation.

--------------------

HOW TO USE
-drag the component to the scene
-give the instance a beautiful name (i.e:my_3d)
!it's highly recommended to crete methods for model creation so you don't have
to write in the scene the step by step for every polygon
-create a method to simplify model creation (i.e. square)
function square(){
var mo = new Model()
//coord 0
mo.addCoord(new Coord(0, 0, 0));
//coord 1
mo.addCoord(new Coord(50, 0, 0));
//coord 2
mo.addCoord(new Coord(50, 50, 0));
//coord 3
mo.addCoord(new Coord(0, 50, 0));

var ld = [];
ld.push([0, 'moveTo']);
ld.push([1, 'lineTo']);
ld.push([2, 'lineTo']);
ld.push([3, 'lineTo']);
ld.push([0, 'lineTo']);
mo.addPolygon(new Polygon(ld));

return mo
}

-create the scene (a function) that will create the camera and models
var sc1 = function (engine) {
// Create camera
var c = engine.setCamera(new Camera3D());
c.setCoordinates(0, 0, -100);
c.setRotation(0, 0);
// Create model
var m = engine.addModel(_root.square());
m.setCoordinates(0, 0, 0);
m.setColor(200, 224, 204);
}

-add the scene
my_3d.scenes = [sc1];

-set the scene
my_3d.setScene(0)

--------------------
WHAT ARE FREEZE AND EFFECTS?
these are effects over what you see on the screen.
they do not affect the real model but the way they are shown.
--------------------

WHAT IS A SCENE?
a scene must be a function that has an engine parameter to receive an instance of the component.
the engine is needed to create the camera and add the different models.

//////////////////////////////
ESPANOL
proyecto: engine 3d
por: ivan ivanoff (www.i2off.org)
basado en el trabajo de: stuart schoneveld (www.illogicz.com) 
email: avatar@i2off.org
perdones:
A mi mujer e hijos por aguantar.
A jorge, valeria y mariano, por joderlos a cada rato.	
--------------------
ACERCA DE ESTA CLASE
Esta es instanciada por el componente del engine. Es la que contiene el sistema de render y las propiedades globales.
--------------------
ACERCA DE SUS METODOS PUBLICOS
-addModel(model)
agrega un modelo a la escena. El model es una instancia de la clase Model().
devuelve el modelo agregado
-removeModel(model)
remueve un modelo de la escena. El model es una instancia de la clase 
Model() previamente agregada a la escena.
-getModels()
devuelve una lista con todos los modelos disponibles.
-removeCamera(cam)
remueve uns camara de la escena. Cam es una instancia de la clase 
Camera3D().
-setCamera(cam)
agrega y setea la camara que se usa en la escena. Cam es una instancia de 
la clase Camera3D()
-reset()
borra todos los modelos y limpia la escena.
-setScene(int)
setea como activa una escena eliminando a la que se este ejecutando. int es 
un entero que representa el numero de escena de la lista de escenas seteadas
con la propiedad: scenes
-onFreezeModel()
evento a ser sobreescrito que recoge notifica del momento en el cual un 
modelo es freezado.
-addTexture(layer, texture)
este metodo permite que un layer determinado no se dibuje normalmente sino 
como mascara de un objecto en libreria (texture)
--------------------

ACERCA DE SUS PROPIEDADES PUBLICAS
-layers
la cantidad de layers distintos que se quieren usar. Uno puede asignar 
modelos a distintos layers. Teniendo en cuenta que a si un objeto esta 
ubicado delante de otro, pero en un layer inferior, se ve por detras.
Los leyers son optimos para el trabajo con texturas (ver addTexture)
-freezeMode
si esta activo o no el modo de freeze. Este lo que hace es dejar de 
redibujar secciones de un modelo freezado.

-porFrezar
la posibilidad global que tienen los modelos de ser freezados.

-FXNMode
si esta activo o no el mode de FXN (1, 2, ETC). Este detiene partes del
poligono afectado, las estira o las contrae.
-FXNFac
factor para el calculo de aplicacion de o de los FXN

-scenes
lista que contiene las distintas escenas. Estas son funciones que reciben 
como parametro la instancia del engine. Cada escena tiene la descripion
paso a caso de la creacion de la camara y cada uno de sus polygonos

--------------------

MODO DE USO
-draguear el componente en la escena
-nombrar la instancia (ej:my_3d)
!es recomendable crear metodos para la creacion de los modelos para no escribir
en la escena toda el paso a paso de cada uno de los polygonos
-crear metodo para simplificar la creacion del modelo (ej: cuadrado)
function cuadrado(){
var mo = new Model()
//coord 0
mo.addCoord(new Coord(0, 0, 0));
//coord 1
mo.addCoord(new Coord(50, 0, 0));
//coord 2
mo.addCoord(new Coord(50, 50, 0));
//coord 3
mo.addCoord(new Coord(0, 50, 0));

var ld = [];
ld.push([0, 'moveTo']);
ld.push([1, 'lineTo']);
ld.push([2, 'lineTo']);
ld.push([3, 'lineTo']);
ld.push([0, 'lineTo']);
mo.addPolygon(new Polygon(ld));

return mo
}

-crear la escena (una funcion) que crea la camara y los modelos
var esc1 = function (engine) {
// Crea la camara
var c = engine.setCamera(new Camera3D());
c.setCoordinates(0, 0, -100);
c.setRotation(0, 0);
// Crea un modelo
var m = engine.addModel(_root.cuadrado());
m.setCoordinates(0, 0, 0);
m.setColor(200, 224, 204);
}

-agrega la escena
my_3d.scenes = [esc1];

-setea la escena
my_3d.setScene(0)

--------------------
QUE ES FREEZADO Y EFFECTS?
son efectos sobre lo que se ve en pantalla. Estos efectos no afectan realmente al modelo. Sino a la forma en la que estos son mostrados
--------------------

QUE ES UNA ESCENA
una escena debe ser una funcion que recivira como parametro la instancia del componente para poder crear en ella la camara y los distintos modelos.


*******************/
//import flash.filters.BlurFilter;
//import flash.filters.GlowFilter;
class engine3D extends MovieClip {
	var depths:Object;
	var models:Object;
	var cameras:Object;
	var camera:Object;
	var depositoGrafico:MovieClip;
	var layers:Number = 1;
	//cuantos layers graficos tiene
	var idModels = 1;
	var freezeMode = false;
	var porFrezar = 10;
	var porPoligF = 1;
	//la posibilidad de dibujar el poligonoF
	var FX1Mode = false;
	var FX2Mode = false;
	var FX3Mode = false;
	var FX1Fac = 10;
	var FX2Fac = 10;
	var FX3ModeX = 0;
	var scenes:Array;
	//esto es para ver que cosa se dibuja y que cosa no
	var areaLeft = -150;
	var areaRight = 150;
	var areaTop = -150;
	var areaBot = 150;
	function engine3D() {
		_global.engine3DRun = this;
		_global.engine3DCore = new Object();
		depths = new Object();
		models = new Object();
		camera = undefined;
		cameras = new Object();
	}
	function init(l) {
		//el movieclip tiene que tener en el primer frame un llamado al init
		if (l == null || l == undefined || typeof (l) != "number") {
			l = 1;
		}
		layers = l;
		this.createEmptyMovieClip("depositoGrafico", 1);
		for (var i = 0; i<l; i++) {
			var la = depositoGrafico.createEmptyMovieClip("layer"+i, (i+1)*2);
			la._depth = (i+1)*2;
			la.ids = 0;
		}
	}
	function addModel(model) {
		models[model._id] = model;
		model.onAdd(this);
		return model;
	}
	function removeModel(model) {
		models[model._id].onRemove();
		delete models[model._id];
	}
	function getModels() {
		return models;
	}
	function removeCamera(cam) {
		delete cameras[camera._id];
	}
	function setCamera(cam) {
		return camera=cam;
	}
	function reset() {
		var rT = render;
		render = null;
		for (var i in models) {
			models[i].onRemove();
		}
		delete models;
		depths = new Object();
		models = new Object();
		camera = undefined;
		cameras = new Object();
		idModels = 1;
		removeMovieClip(depositoGrafico);
		this.createEmptyMovieClip("depositoGrafico", 1);
		for (var j = 0; j<layers; j++) {
			var la = depositoGrafico.createEmptyMovieClip("layer"+j, (j+1)*2);
			la._depth = (j+1)*2;
			la.ids = 0;
		}
		render = rT;
	}
	function clearScene() {
		for (var i in models) {
			models[i].onRemove();
			//delete models[model._id];
		}
		models = {};
		idModels = 1;
	}
	//function onEnterFrame() {
	//	render();
	//}
	function render() {
		depths = new Object();
		var c = camera;
		if (c.doLink == true) {
			if (c.doLinkRota == true) {
				var lr = c.link.getRotation();
				var xr = lr.y+c.linkRotaOffsetAngle;
				var offR = c.linkRotaOffsetZ;
				var off = c.linkOffset;
				off.z = Math.sin(xr)*offR;
				off.x = Math.cos(xr)*offR;
			}
			if (c.linkTipoEasyng == 1) {
				var cCoord = c.getCoordinates();
				//trace(cCoord.x +":"+cCoord.y+":")
				var lCoord = c.link.getCoordinates();
				var lpar = c.linkParamsEasyng[0];
				var off = c.linkOffset;
				var dif = {x:(lCoord.x+off.x)-cCoord.x, y:(lCoord.y+off.y)-cCoord.y, z:(lCoord.z+off.z)-cCoord.z};
				//trace(dif.x+":"+dif.y+":" +dif.z)
				var step = {x:dif.x*lpar, y:dif.y*lpar, z:dif.z*lpar};
				//trace(step.x +":"+step.y+":"+step.z)
				c.setCoordinates(cCoord.x+step.x, cCoord.y+step.y, cCoord.z+step.z);
			}
		}
		if (c.doPivot == true) {
			var PIVOTold = c.pivotOldCoord;
			var PIVOTccoor = c.getCoordinates();
			var PIVOTccoorold = c.camOldCoord;
			var PIVOTpcoor = c.pivot.getCoordinates();
			if (PIVOTccoorold.x != PIVOTccoor.x || PIVOTccoorold.y != PIVOTccoor.y || PIVOTccoorold.z != PIVOTccoor.z || PIVOTold.x != PIVOTpcoor.x || PIVOTold.y != PIVOTpcoor.y || PIVOTold.z != PIVOTpcoor.z || c.doLinkRota == true) {
				//le agrego que esto lo haga si c.doLinkRota==true porque quizas solo roto al pivot
				if (PIVOTpcoor.z>=PIVOTccoor.z) {
					//rx
					var r = Math.atan2(PIVOTpcoor.x-PIVOTccoor.x, PIVOTpcoor.z-PIVOTccoor.z);
					//ry
					var iz1 = PIVOTccoor.z;
					var iz2 = PIVOTpcoor.z;
					var ix1 = PIVOTccoor.x;
					var ix2 = PIVOTpcoor.x;
					var ipo = Math.sqrt((ix2-ix1)*(ix2-ix1)+(iz2-iz1)*(iz2-iz1));
					//trace(ipo);
					var r2 = Math.atan2(PIVOTpcoor.y-PIVOTccoor.y, ipo);
					//var r2 = Math.atan2(PIVOTpcoor.y-PIVOTccoor.y, PIVOTpcoor.z-PIVOTccoor.z);
				} else {
					//rx
					var r = Math.atan2(PIVOTpcoor.x-PIVOTccoor.x, PIVOTpcoor.z-PIVOTccoor.z);
					var iz1 = PIVOTpcoor.z;
					var iz2 = PIVOTccoor.z;
					var ix1 = PIVOTccoor.x;
					var ix2 = PIVOTpcoor.x;
					var ipo = Math.sqrt((ix2-ix1)*(ix2-ix1)+(iz2-iz1)*(iz2-iz1));
					//trace(ipo);
					var r2 = Math.atan2(PIVOTpcoor.y-PIVOTccoor.y, ipo);
				}
				/*if (r>1.5707963267949) {
				var rr = r%1.5707963267949;
				} else {
				var rr = r;
				}*/
				c.setRotation(-r2, r);
				c.pivotOldCoord = new Object();
				c.pivotOldCoord.x = PIVOTpcoor.x;
				c.pivotOldCoord.y = PIVOTpcoor.y;
				c.pivotOldCoord.z = PIVOTpcoor.z;
				c.camOldCoord = new Object();
				c.camOldCoord.x = PIVOTccoor.x;
				c.camOldCoord.y = PIVOTccoor.y;
				c.camOldCoord.z = PIVOTccoor.z;
			}
		}
		var mr = models;
		//!!!!!!!!!!!ESTA PARTE DESPUES PODRIA HACERLA SOLO CUANDO SE MUEVE LA CAMARA
		var cx = c.x;
		var cy = c.y;
		var cz = c.z;
		var fov = c.fov;
		var xsin = Math.sin(c.xrot);
		var xcos = Math.cos(c.xrot);
		var ysin = Math.sin(c.yrot);
		var ycos = Math.cos(c.yrot);
		//!!!!!!!!!!!
		for (var i in mr) {
			var m = mr[i];
			if (m.doOnTicker == true) {
				m.onTicker();
			}
			if (m.isLinked == true) {
				m.renderLink();
			}
			//if (m.isFreezado != true) {         
			var pl = m.coords;
			var inv = false;
			var cpol = -1;
			//con esto chequeo si al menos un punto entra dentro del area. si no entra ninguno, no dibujo
			var pdentro = false;
			var minX = null;
			var maxX = null;
			var minY = null;
			var maxY = null;
			for (var j in pl) {
				var invInt = false;
				cpol++;
				var p = pl[j];
				var px = p.wx-cx;
				var py = p.wy-cy;
				var pz = p.wz-cz;

				var x = ycos*px-ysin*pz;
				var tz = ycos*pz+ysin*px;
				var z = xcos*tz-xsin*py;
				var y = xcos*py+xsin*tz;
				var k = fov/z;
				/*if (k<0) {
				inv = true;
				break;
				}*/
				p.k = k;
				//esta linea que sigue la pongo aca, porque es en verda el if de los fx, esto es para ahorrarme el else
				p.vx = x*k;
				if (FX1Mode == true && m.doFX1 == true) {
					if (m.coordsFX1[cpol] != undefined && m.coordsFX1[cpol] != null) {
						p.vx = x*k+(FX1Fac+m.modFacFX1);
					}
				}
				if (FX2Mode == true && m.doFX2 == true) {
					if (p.vx>0) {
						p.vx = (x*k)*((x*k)/(FX2Fac+m.modFacFX2));
					}
				}
				p.vy = y*k;
				p.vz = z;
				if (p.vx>areaLeft && p.vx<areaRight && p.vy>areaTop && p.vy<areaBot) {
					pdentro = true;
				}
				if (p.vx<minX || minX == null) {
					minX = p.vx;
				}
				if (p.vx>maxX || maxX == null) {
					maxX = p.vx;
				}
				if (p.vy<minY || minY == null) {
					minY = p.vy;
				}
				if (p.vy>maxY || maxY == null) {
					maxY = p.vy;
				}
			}
			if (pdentro == false) {
				var safa = false;
				if (areaLeft>minX && areaLeft<maxX && areaTop>minY && areaTop<maxY) {
					safa = true;
				} else if (areaLeft>minX && areaLeft<maxX && areaBot>minY && areaBot<maxY) {
					safa = true;
				} else if (areaRight>minX && areaRight<maxX && areaTop>minY && areaTop<maxY) {
					safa = true;
				} else if (areaRight>minX && areaRight<maxX && areaBot>minY && areaBot<maxY) {
					safa = true;
				}
				if (minX>areaLeft && maxX<areaRight && minY<areaTop && maxY>areaBot) {
					safa = true;
				}
				if (minX<areaLeft && maxX>areaRight && minY>areaTop && maxY<areaBot) {
					safa = true;
				}
				if (!safa) {
					inv = true;
				}
			}
			//}         
			if (inv) {
				var pr = m.polygons;
				for (var j in pr) {
					var prjm = pr[j].mc;
					prjm.dr.clear();
					for (var j2 in prjm.at) {
						//trace(j2);
						if (prjm.at[j2].removeTextField != null && prjm.at[j2].removeTextField == undefined) {
							prjm.at[j2].removeTextField();
							//prjm.at[j2].removeMovieClip();
						} else {
							prjm.at[j2].removeMovieClip();
						}
						//trace(prjm.at[j2]);
						//removeMovieClip(prjm.at[j2]);
					}
					pr[j].isDisplayed= false
				}
				m.isDisplayed = false;
				continue;
			}
			//esto es si no es invisible      
			var pr = m.polygons;
			//var coo = m.coords
			//no, para eso ya esta pl, que son las coords

			for (var j in pr) {
				var sale = false;
				for (var lld in pr[j].listaDibujar) {
					if (pl[pr[j].listaDibujar[lld][0]].k<0) {
						sale = true;
					}
				}
				if (sale) {
					var prjm = pr[j].mc;
					prjm.dr.clear();
					for (var j2 in prjm.at) {
						if (prjm.at[j2].removeTextField != null && prjm.at[j2].removeTextField == undefined) {
							prjm.at[j2].removeTextField();
							//prjm.at[j2].removeMovieClip();
						} else {
							prjm.at[j2].removeMovieClip();
						}
						//prjm.at[j2].removeMovieClip();
						//removeMovieClip(prjm.at[j2]);
					}
					pr[j].isDisplayed = false;
				} else {

					var p = pr[j];
					if (freezeMode == true) {
						if (m.isFreezable == true && p.isFreezado == false) {
							if (random(porFrezar+m.modPorFrezar) == 0) {
								onFreezeModel(m, p, pl);
								p.isFreezado = true;
								//m.isFreezado = true
							}
						}
					} else {
						p.isFreezado = false;
						//m.isFreezado = false
					}
					if (p.isFreezado != true) {
						if (m._isTextured == true && m._isTextureDinamic == true) {
							var mctx = p.mc.tx;
							mctx._x = minX;
							mctx._y = minY;
							mctx._width = maxX-minX+30;
							mctx._height = maxY-minY+30;
						}
						var mcdr = p.mc.dr;
						var mcat:MovieClip = p.mc.at;
						mcdr.clear();
						if (m.isColorVar == true) {
							if (p.modColorF == null) {
								var vc = random(m.modColorA)+m.modColorB;
								p.modColorF = vc;
							} else {
								var vc = p.modColorF;
							}
						} else {
							var vc = 0;
						}
						if (m.withoutfill != true) {
							var rvc = Math.max(Math.min(255, (m.red+vc)),0);
							var gvc = Math.max(Math.min(255, (m.green+vc)),0);
							var bvc = Math.max(Math.min(255, (m.blue+vc)),0);
							//mcdr.beginFill((m.red+vc) << 16 | (m.green+vc) << 8 | (m.blue+vc), m.alpha);
							mcdr.beginFill(rvc << 16 | gvc << 8 | bvc, m.alpha);
						}
						var u = 0;
						var atts = 0;
						//para llevar el control de los attachs
						//var zz = 0;
						var cuentaPuntos = new Object();
						if (FX3Mode == true) {
							var FX3ModeAbierto = false;
							var FX3ModeUltimo = {};
						}
						for (var ii = 0; ii<p.listaDibujar.length; ii++) {
							var pi = p.listaDibujar[ii];
							//pi = [coordIndice, tipo, [params]]
							var Tcoo = pl[pi[0]];
							//FX3Mode
							switch (pi[1]) {
							case "lineTo" :
								//zz += Tcoo.vz;
								cuentaPuntos[pi[0]] = Tcoo.vz;
								if (FX3Mode == true) {
									if (Tcoo.vx>FX3ModeX) {
										if (FX3ModeAbierto == false) {
											FX3ModeAbierto = true;
										}
										mcdr.lineTo(areaRight+20, FX3ModeUltimo.vy);
										if (ii == p.listaDibujar.length-1) {
											//trace("a");
											mcdr.lineTo(areaRight+20, Tcoo.vy);
											mcdr.lineTo(Tcoo.vx, Tcoo.vy);
										}
									} else {
										if (FX3ModeAbierto == false) {
											FX3ModeUltimo.vx = Tcoo.vx;
											FX3ModeUltimo.vy = Tcoo.vy;
										} else {
											FX3ModeAbierto = false;
											mcdr.lineTo(areaRight+20, Tcoo.vy);
										}
										mcdr.lineTo(Tcoo.vx, Tcoo.vy);
									}
								} else {
									mcdr.lineTo(Tcoo.vx, Tcoo.vy);
								}
								break;
							case "moveTo" :
								if (FX3Mode == true) {
									if (FX3ModeAbierto == false) {
										FX3ModeUltimo.vx = Tcoo.vx;
										FX3ModeUltimo.vy = Tcoo.vy;
									}
								}
								mcdr.moveTo(Tcoo.vx, Tcoo.vy);
								break;
							case "curveTo" :
								//zz += Tcoo.vz;
								cuentaPuntos[pi[0]] = Tcoo.vz;
								var Tcoo2 = pl[pi[2][0]];
								if (FX3Mode == true) {
									if (Tcoo.vx>FX3ModeX) {
										if (FX3ModeAbierto == false) {
											FX3ModeAbierto = true;
										}
										mcdr.lineTo(areaRight+20, FX3ModeUltimo.vy);
										if (ii == p.listaDibujar.length-1) {
											//trace("a");
											mcdr.lineTo(areaRight+20, Tcoo.vy);
											mcdr.lineTo(Tcoo.vx, Tcoo.vy);
										}
									} else {
										if (FX3ModeAbierto == false) {
											FX3ModeUltimo.vx = Tcoo.vx;
											FX3ModeUltimo.vy = Tcoo.vy;
										} else {
											FX3ModeAbierto = false;
											mcdr.lineTo(areaRight+20, Tcoo.vy);
										}
										mcdr.curveTo(Tcoo2.vx, Tcoo2.vy, Tcoo.vx, Tcoo.vy);
									}
								} else {
									mcdr.curveTo(Tcoo2.vx, Tcoo2.vy, Tcoo.vx, Tcoo.vy);
								}
								break;
							case "beginFill" :
								//trace(pi[2][0]+":"+ pi[2][1])
								mcdr.beginFill(pi[2][0], pi[2][1]);
								break;
							case "lineStyle" :
								mcdr.lineStyle(pi[2][0], pi[2][1], pi[2][2]);
								break;
							case "attach" :
								//zz += Tcoo.vz;
								cuentaPuntos[pi[0]] = Tcoo.vz;
								var atid = atts++;
								if (p.isDisplayed == false) {
									var atmc = mcat.attachMovie(pi[2][0], "a"+atid, atid+1);
								} else {
									var atmc = mcat["a"+atid];
								}
								atmc._x = Tcoo.vx;
								atmc._y = Tcoo.vy;
								var sc = 1;
								if(pi[2][1]!=null && pi[2][1] != undefined){
									sc = pi[2][1]
								}
								atmc._xscale = atmc._yscale=(int(k*100)*sc);
								break;
							case "text" :
								//zz += Tcoo.vz;
								//pi[2][0] = format
								//pi[2][1] = text
								//pi[2][2] = w
								//pi[2][3] = size
								cuentaPuntos[pi[0]] = Tcoo.vz;
								var atid = atts++;
								if (p.isDisplayed == false) {
									var fmt = pi[2][0];
									var p = 0;
									if (fmt.align == "rigth") {
										p = -pi[2][2];
									} else if (fmt.align == "center") {
										p = -pi[2][2]/2;
									}
									var atmcp = mcat.createEmptyMovieClip("a"+atid, atid+1) 
									atmc = atmcp.createTextField("txt_"+atid, atid, p, 0, pi[2][2], 400);
									//trace(pi[2][0]+":"+pi[2][1]+":"+pi[2][2]+":"+pi[2][3]);
									atmc.multiline = true;
									atmc.wordWrap = true;
									atmc.embedFonts = true;
									atmc.selectable = false;
									atmc.text = pi[2][1];
									atmc.setTextFormat(fmt);
									//trace(pi[2][3]);
									//atmc._yscale = atmc._xscale=pi[2][3];
									//var atmc = mcat.attachMovie(pi[2][0], "a"+atid, atid+1);
								} else {
									//var atmc = mcat["txt_"+atid];
									var atmc = mcat["a"+atid];
								}
								atmc._x = Tcoo.vx;
								atmc._y = Tcoo.vy;
								atmc._xscale = atmc._yscale=int(k*100);
								break;
							case "attachif" :
								//zz += Tcoo.vz;
								cuentaPuntos[pi[0]] = Tcoo.vz;
								var atid = atts++;
								if (random(pi[2][1]) == 0) {
									var atmc = mcat.attachMovie(pi[2][0], "a"+atid, atid+1);
								}
								atmc._x = Tcoo.vx;
								atmc._y = Tcoo.vy;
								atmc._xscale = atmc._yscale=int(k*100);
								break;
							case "attachFreeze" :
								var atid = atts++;
								break;
							case "attachFreezeAnim" :
								//no reatachea
								var atid = atts++;
								break;
							case "attachFreezeRandom" :
								//que sea una lista paa atachar
								var atid = atts++;
								break;
							}
							
						}
						mcdr.endFill();
						
						var cdep = 0;
						var cdepT = 0;
						for (var dep in cuentaPuntos) {
							cdep++;
							cdepT += cuentaPuntos[dep];
						}
						var cdepF = cdepT/cdep;
						var dd = m.modDepth-int(cdepF*10);
						while (depths["d"+dd] == true) {
							dd--;
						}
						depths["d"+dd] = true;
						p.mc.swapDepths(dd);
						p.mc.cacheAsBitmap = true
					}
					if (m.isFreezado != true) {
						pr[j].isDisplayed = true;
					}
				}
			}
		}
	}
	function setScene(s) {
		reset();
		scenes[s](this);
	}
	function onFreezeModel(model, polygon, coords) {
	}
	function addTexture(l, t, tr, tm, ff, fm) {
		var d = depositoGrafico["layer"+l]._depth;
		var m = depositoGrafico.attachMovie(t, "t"+l, d-1,{trans:tr,transMatrix:tm, fondo:ff, fondoMatrix:fm});
		m._x = -240
		m._y = -180
		m._width = 480
		m._height = 380
		depositoGrafico["layer"+l]._mask = m;
		m.setMask(depositoGrafico["layer"+l]);
	}
	function remTexture(l) {
		depositoGrafico["t"+l].setMask(null);
		removeMovieClip(depositoGrafico["t"+l]);
		depositoGrafico["t"+l].removeMovieClip();
		delete depositoGrafico["layer"+l]._mask;
	}
	/*function setBlurTexture (l, blurX, blurY, quality) {
	var filter:BlurFilter = new BlurFilter(blurX, blurY, quality);
	var filterArray:Array = new Array();
	filterArray.push(filter);
	depositoGrafico["t"+l].filters = filterArray;
	
	//rect.filters = filterArray;
	}
	function setGlowTexture(l,color, alpha, blurX, blurY, strength, quality, inner, knockout) {
	var filter:GlowFilter = new GlowFilter(color, alpha, blurX, blurY, strength, quality, inner, knockout);
	var filterArray:Array = new Array();
	depositoGrafico["t"+l].filters = filterArray;
	//}
	//rect.filters = filterArray;
	}*/
}
